create or replace package body count_report
is
  PROCEDURE process_report
  is
    m_id INTEGER := 0;
    m_name VARCHAR2(255);
    cursor c1 is 
      select ci.city_name||', '||co.country_name, ci.city_id 
      from city ci, country co
      where co.country_id = ci.country_id
      order by co.region_id, co.country_name, city_name;
  BEGIN
    process_header;
    OPEN c1;
    LOOP
      FETCH c1 INTO m_name,m_id;
      EXIT WHEN c1%NOTFOUND;
      process_interest(m_name, m_id);
    END LOOP;
    CLOSE c1;
  END process_report; 
  PROCEDURE process_interest (m_name IN VARCHAR2, m_id IN INTEGER)
  is
    line_length INTEGER := 0;
    display_flag INTEGER := 0;
    i_id INTEGER := 0;
    i_name VARCHAR2(35);
    total VARCHAR2(35);
    total_string VARCHAR2(255);
    total_string2 VARCHAR2(255);
    cursor c1 is 
      select int_name, int_id from interest order by 1;
  BEGIN
    OPEN c1;
    LOOP
      FETCH c1 INTO i_name, i_id;
      EXIT WHEN c1%NOTFOUND;
      get_count(m_id, i_id, m_name, total);
      IF total != '0'
      THEN
        display_flag := 1;
      END IF;
      total_string := total_string||total||',';
    END LOOP;
    CLOSE c1;
    line_length := LENGTH(total_string);
    total_string2 := SUBSTR(total_string,0,line_length-1);
    IF display_flag = 1
    THEN
      DBMS_OUTPUT.PUT_LINE(m_name||','||total_string2);
    END IF;
  END process_interest;
  PROCEDURE get_count (m_id IN INTEGER, i_id IN INTEGER, m_name IN VARCHAR2, total OUT VARCHAR2)
  is
  BEGIN
    SELECT to_char(abstract_count) INTO total 
      from TRAVELOCITY_CIT_INT_COUNTS
      where city_id = m_id
      and int_id = i_id;
  EXCEPTION
    WHEN OTHERS
    THEN
    total := '0';
  END get_count;
  PROCEDURE process_header
  is
    i_name VARCHAR2(35);
    cursor c1 is
      select int_name from interest order by 1;
  BEGIN
    OPEN c1;
    LOOP
      FETCH c1 INTO i_name;
      EXIT WHEN c1%NOTFOUND;
      DBMS_OUTPUT.PUT_LINE(i_name||',');
    END LOOP;
    CLOSE c1;
  END process_header;
END count_report;

